//
//  AZViewController.m
//  FontShow
//
//  Created by Aladdin Zhang on 9/28/11.
//  Copyright (c) 2011 Innovation-Works. All rights reserved.
//

#import "AZViewController.h"
#import "OHAttributedLabel.h"
#import "NSAttributedString+Attributes.h"
#import "AZFontShowCell.h"
@implementation AZViewController
- (void)perpareData{
    NSArray *familyNames = [[NSArray alloc] initWithArray:[UIFont familyNames]];
    NSArray *fontNames;
    NSInteger indFamily, indFont;
    for (indFamily=0; indFamily<[familyNames count]; ++indFamily)
    {
        //printf("Family name: %s\n", [[familyNames objectAtIndex:indFamily] UTF8String]);
        fontNames = [[NSArray alloc] initWithArray:
                     [UIFont fontNamesForFamilyName:
                      [familyNames objectAtIndex:indFamily]]];
        for (indFont=0; indFont<[fontNames count]; ++indFont)
        {
            //            printf("    Font name: %s\n", [[fontNames objectAtIndex:indFont] UTF8String]);
            [fontArray addObject:[fontNames objectAtIndex:indFont]];
        }
    }
    
}
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
            fontArray = [NSMutableArray arrayWithCapacity:30];
    }
    return self;
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self perpareData];
    sizeOfFont.value = 15;
    [self adjustSize:nil];
    sizeOfLineHeight.value = 10;
    [self adjustLineHeightSize:nil];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    NSInteger modelIndex = (int)indexPath.section;
        UIFont * font = [UIFont fontWithName:[fontArray objectAtIndex:modelIndex] size:fontSize];
    NSMutableAttributedString * textStr = [NSMutableAttributedString attributedStringWithString:[NSString stringWithFormat:@"font:%@ size:%d \n%@",[fontArray objectAtIndex:modelIndex],fontSize,[sampleText text]]];
    [textStr setTextAlignment:kCTLeftTextAlignment lineBreakMode:kCTLineBreakByCharWrapping lineSpace:lineHeightSize];//font.lineHeight/2+font.descender+
    [textStr setFont:font];
    CGSize s = [textStr sizeConstrainedToSize:CGSizeMake(300, CGFLOAT_MAX)];
    return s.height+10;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 1;
}
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return [fontArray count];
}
static NSString * normalCellIndentifier = @"normalCellIndentifier";
static NSString * ohAcellIndentifier = @"ohAcellIndentifier";
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
//    if(indexPath.row%2==0){
        NSInteger modelIndex = (int)indexPath.section;
        AZFontShowCell * cell = (AZFontShowCell*)[tableView dequeueReusableCellWithIdentifier:ohAcellIndentifier];
        UIFont * font = [UIFont fontWithName:[fontArray objectAtIndex:modelIndex] size:fontSize];
        if (!cell) {
            cell = [[AZFontShowCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:ohAcellIndentifier];
            [cell.textLabel setNumberOfLines:40];
            [cell.textLabel setLineBreakMode:UILineBreakModeCharacterWrap];
        }
    OHAttributedLabel * attLabel = (OHAttributedLabel*)cell.textLabel;
    [attLabel setNumberOfLines:40];
    
    [attLabel setFont:[UIFont fontWithName:[fontArray objectAtIndex:modelIndex] size:fontSize]];
    
    NSMutableAttributedString * textStr = [NSMutableAttributedString attributedStringWithString:[NSString stringWithFormat:@"font:%@ size:%d \n%@",[fontArray objectAtIndex:modelIndex],fontSize,[sampleText text]]];
    [textStr setTextAlignment:kCTLeftTextAlignment lineBreakMode:kCTLineBreakByCharWrapping lineSpace:lineHeightSize];
    [attLabel setLineBreakMode:UILineBreakModeCharacterWrap];
    [textStr setFont:font];
    [attLabel setFrame:CGRectMake(10, 5, 300,[textStr sizeConstrainedToSize:CGSizeMake(300, CGFLOAT_MAX)].height)];
    
    attLabel.attributedText = textStr;
    [attLabel setNeedsDisplay];
    return cell;  
//    }else{
//        NSInteger modelIndex = (int)indexPath.row/2;
//        UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:normalCellIndentifier];
//        UIFont * font = [UIFont fontWithName:[fontArray objectAtIndex:modelIndex] size:fontSize];
//        if (!cell) {
//            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:normalCellIndentifier];
//            [cell.textLabel setNumberOfLines:20];
//            [cell.textLabel setLineBreakMode:UILineBreakModeClip];
//        }
//        [cell.textLabel setFrame:CGRectMake(0, 5, 300,[[NSString stringWithFormat:@"%@ \n%@",[fontArray objectAtIndex:modelIndex],[sampleText text]] sizeWithFont:font constrainedToSize:CGSizeMake(300, 999999999) lineBreakMode:UILineBreakModeClip].height+5)];
//        [cell.textLabel setFont:font];
//        cell.textLabel.text =[NSString stringWithFormat:@"font:%@ size:%d \n%@",[fontArray objectAtIndex:modelIndex],fontSize,[sampleText text]];
//        return cell; 
//    }
}
- (void)scrollViewDidScroll:(UIScrollView *)scrollView{

    if ([sampleText isFirstResponder]) {
        [sampleText resignFirstResponder];
         [self performSelector:@selector(refreshTableview) withObject:nil afterDelay:0.1];   
    }
    
}
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    return [fontArray objectAtIndex:section];
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [self performSelector:@selector(refreshTableview) withObject:nil afterDelay:0.1];   
}
- (void)refreshTableview{
    NSArray * cells = [list visibleCells];
    NSMutableArray * indexes = [NSMutableArray arrayWithCapacity:[cells count]];
    for (UITableViewCell * c in cells) {
        [indexes addObject:[list indexPathForCell:c]];
    }
    [list beginUpdates];
    [list reloadSectionIndexTitles];
    [list reloadRowsAtIndexPaths:indexes withRowAnimation:UITableViewRowAnimationNone];
    [list endUpdates];
//    [list performSelector:@selector(reloadData) withObject:nil afterDelay:0.1];
}
- (IBAction)adjustSize:(id)sender{
    fontSize = [sizeOfFont value];
    fontSizeLabel.text = [NSString stringWithFormat:@"字号:%d",fontSize];
    [self performSelector:@selector(refreshTableview) withObject:nil afterDelay:0.1];   
}
- (IBAction)adjustLineHeightSize:(id)sender{
    lineHeightSize = [sizeOfLineHeight value];
    fontLineHeightLabel.text = [NSString stringWithFormat:@"行高:%d",lineHeightSize];
    [list performSelector:@selector(reloadData) withObject:nil afterDelay:0.1];       
}
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        [fontArray removeObjectAtIndex:indexPath.row];
        [list beginUpdates];
        [list deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationMiddle];
        [list endUpdates];
    }
}
@end
